using System.Collections;
using System.Collections.Generic;
using DefaultNamespace;
using Unity.VisualScripting;
using UnityEngine;
using TMPro;

public class GameDirector : MonoBehaviour
{
    [SerializeField] private EnemyVariant1 enemyVariant1;
    [SerializeField] private EnemyVariant2 enemyVariant2;
    [SerializeField] private EnemyVariant3 enemyVariant3;
    [SerializeField] private EnemyVariant4 enemyVariant4;
    private int _currentWave = 0;
    private int realwave = 0;
    private int _enemies = 0;
    private List<Wave> _waves;
    public TextMeshProUGUI wavetext;
    private AudioSource aS;
    public AudioClip expl;

    private void Start()
    {
        aS = GetComponent<AudioSource>();
        _waves = new List<Wave>();

        AddNewWave(
            new Wave(
            new Wave.WavePair(
                new Vector3(5,2,0),
                enemyVariant1
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(4.5f,2, 0),
                    enemyVariant2
                    ),
            new Wave.WavePair(
                new Vector3(4.5f, -2, 0),
                enemyVariant1
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(0, 0,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(1,3,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(1, -3,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(2, 0,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(3, 3, 0),
                    enemyVariant1
                ),
                new Wave.WavePair(
                    new Vector3(3, -3, 0),
                    enemyVariant1
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(0, 0,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(1,3,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(1, -3,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(4, 4, 0),
                    enemyVariant1
                ),
                new Wave.WavePair(
                    new Vector3(4, -4, 0),
                    enemyVariant2
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(0, -3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(0, 3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(2,3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(2, -3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(4, -3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(4, 3, 0),
                    enemyVariant3
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(0,0,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(2,0,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(4,0,0),
                    enemyVariant3
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(0, -3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(0, 3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(2,3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(2, -3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(4, -3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(4, 3, 0),
                    enemyVariant3
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(5,2,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(5,-2,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(3,3,0),
                    enemyVariant2
                ),
                new Wave.WavePair(
                    new Vector3(3,0,0),
                    enemyVariant2
                ),
                new Wave.WavePair(
                    new Vector3(3,-3,0),
                    enemyVariant2
                ),
                new Wave.WavePair(
                    new Vector3(1,2,0),
                    enemyVariant1
                ),
                new Wave.WavePair(
                    new Vector3(1,-2,0),
                    enemyVariant1
                ),
                new Wave.WavePair(
                    new Vector3(-1,3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(-1,0,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(-1,-3,0),
                    enemyVariant3
                )
            )
        );
        
        AddNewWave(
            new Wave(
                new Wave.WavePair(
                    new Vector3(5,5,0),
                    enemyVariant1
                ),
                new Wave.WavePair(
                    new Vector3(5, 3,0),
                    enemyVariant2
                ),
                new Wave.WavePair(
                    new Vector3(5,1,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(5, -1,0), 
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(5, -3,0),
                    enemyVariant1
                ),
                new Wave.WavePair(
                    new Vector3(5, -4, 0),
                    enemyVariant2
                ),
                new Wave.WavePair(
                    new Vector3(3,5,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(3, 3,0),
                    enemyVariant3
                ),
                new Wave.WavePair(
                    new Vector3(3,1,0),
                    enemyVariant2
                ),
                new Wave.WavePair(
                    new Vector3(3, -1,0), 
                    enemyVariant1
                ),
                new Wave.WavePair(
                    new Vector3(3, -3,0),
                    enemyVariant4
                ),
                new Wave.WavePair(
                    new Vector3(3, -4, 0),
                    enemyVariant3
                )
            )
        );
        _enemies = _waves[0].SpawnWave();
    }

    public void AddNewWave(Wave wave)
    {
        _waves.Add(wave);
    }

    public void EnemyDeath()
    {
        aS.PlayOneShot(expl, 1f);
        _enemies -= 1;
        if (_enemies == 0)
        {
            _currentWave += 1;
            realwave += 1;
            if (_currentWave > _waves.Count - 1)
            {
                _currentWave = 2;
                var w4ve = _waves[_currentWave];
                _enemies = w4ve.SpawnWave();
                return;
            }
            var wave = _waves[_currentWave];
            if (wave != null)
            {
                _enemies = wave.SpawnWave();
            }
        }
    }

    void Update() {
        wavetext.text = $"WAVE: {realwave + 1}";
        if (realwave > PlayerPrefs.GetInt("wavecount"))
            PlayerPrefs.SetInt("wavecount", realwave);
    }
}
