﻿using System.Collections.Generic;
using UnityEngine;

namespace DefaultNamespace
{
    public class Wave
    {
        
        public class WavePair
        {
            private Vector3 _position;
            private Enemy _enemy;

            public WavePair(Vector3 pos, Enemy enemy)
            {
                this._enemy = enemy;
                this._position = pos;
            }

            public Vector3 GetPosition()
            {
                return _position;
            }

            public Enemy GetEnemy()
            {
                return _enemy;
            }
            
        }
        
        private readonly ICollection<WavePair> _enemies;
        
        public Wave(params WavePair[] enemies)
        {
            _enemies = new List<WavePair>();
            foreach (var enemy in enemies)
            {
                _enemies.Add(enemy);
            }
        }

        public int SpawnWave()
        {
            int enemyNumber = _enemies.Count;
            foreach (var pair in _enemies)
            {
                var enemy = pair.GetEnemy();
                var position = pair.GetPosition();
                enemy.Spawn(position);
            }

            return enemyNumber;
        }
    }
}